'Program zegara wykorzystujcego przerwania od Timer1
'Przerwanie przepenienia Timer1 jest generowane co 1 s
'8 MHz/256/31250 = 1 s
'Przycisk S1 ustawia minuty, a S2 godziny

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
      'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
      'o czstotliwoci oscylatora
      'taktujcego mikrokontroler
Config Pinb.1 = Input                                       'linia PB1 jako wejciowa
Config Pinb.2 = Input                                       'linia PB2 jako wejciowa
Config Lcd = 16 * 2                                         'konfiguracja typu wywietlacza
      'LCD
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5       'konfiguracja linii
      'mikrokontrolera, do ktrych
      'doczono wywietlacz
      'LCD
Config Timer1 = Timer , Prescale = 256
      'konfiguracja Timer1 jako timer
      'z podziaem preskalera przez
      '256

Declare Sub Wysw_czas                                       'procedura wywietlajca czas na
      'LCD w formacie gg:mm:ss
On Timer1 Odmierz_1s                                        'przerwanie od przepenienia
      'Timer1 o etykiecie Odmierz_1s

Dim Sekundy As Byte                                         'zmienna zliczajca sekundy
Dim Minuty As Byte                                          'zmienna zliczajca minuty
Dim Godziny As Byte                                         'zmienna zliczajca godziny
Dim Nowa_w As Bit                                           'flaga zezwolenia aktualizacji
      'czasu na LCD
Dim Wart_bcd As Byte                                        'zmienna pomocnicza, w ktrej
      'jest zapisywana warto BCD
      'czasu

S1 Alias Pinb.2                                             'przypisanie nazwie Pinb.2
      'nazwy S1
S2 Alias Pinb.1                                             'przypisanie nazwie Pinb.1
      'nazwy S2

Enable Interrupts                                           'odblokowanie globalnego systemu
      'przerwa
Enable Timer1                                               'odblokowanie przerwania od
      'przepenienia Timer1
Counter1 = 34286                                            'warto pocztkowa wpisywana do
      'Timer1 (65536 - 31250 = 34286)

Set Nowa_w                                                  'zezwolenie na wywietlenie
      'aktualnego czasu
Set Portb.1                                                 'doczenie do linii PB1
      'rezystora podcigajcego
Set Portb.2                                                 'doczenie do linii PB2
      'rezystora podcigajcego
Do                                                          'ptla gwna programu
 Call Wysw_czas                                             'wywoanie procedury
      'wywietlajcej aktualny czas
 If S1 = 0 Then                                             'jeli przycinity S1, to
  Waitms 25                                                 'opnienie dla eliminacji drga
      'stykw
  If S1 = 0 Then                                            'sprawdzenie, czy przycisk S1
      'dalej naciniety, jeli tak, to
   Incr Minuty                                              'zwikszenie wartoci minut
   Sekundy = 0                                              'wyzerowanie zmiennej Sekundy
   If Minuty = 60 Then                                      'jeli warto Minuty = 60, to
    Minuty = 0                                              'zerowanie wartoci Minuty
   End If
   Set Nowa_w                                               'zezwolenie na wywietlenie
      'czasu
   Call Wysw_czas                                           'wywoanie procedury
      'wywietlenia aktualnego czasu
   Waitms 200                                               'opnienie 200 ms
  End If                                                    'koniec instrukcji warunkowej
 End If
 If S2 = 0 Then                                             'jeli przycinity S2, to
  Waitms 25                                                 'opnienie dla eliminacji drga
      'stykw
  If S2 = 0 Then                                            'sprawdzenie czy przycisk S2
      'dalej naciniety, jeli tak, to
   Incr Godziny                                             'zwikszenie wartoci Godziny
   If Godziny = 24 Then                                     'jeli warto Godziny = 24, to
    Godziny = 0                                             'wyzerowanie wartoci Godziny
   End If
   Set Nowa_w                                               'zezwolenie na wywietlenie
      'czasu
   Call Wysw_czas                                           'wywoanie procedury
      'wywietlenia aktualnego czasu
   Waitms 200                                               'opnienie 200 ms
  End If                                                    'koniec instrukcji warunkowej
 End If
Loop
End                                                         'koniec programu


Sub Wysw_czas                                               'procedura wywietlajca czas
 If Nowa_w = 1 Then                                         'jeli flaga Nowa_w = 1, to
  Cls                                                       'czyszczenie LCD
  Wart_bcd = Makebcd(godziny)                               'zamiana wartoci Godziny na
      'warto w kodzie BCD
  Lcd Bcd(wart_bcd) ; ":"                                   'wywietlenie wartoci godzin
      'w kodzie BCD zamienionych na
      'tekst oraz znaku :
  Wart_bcd = Makebcd(minuty)                                'zamiana wartoci Minuty na
      'warto BCD
  Lcd Bcd(wart_bcd) ; ":"                                   'wywietlenie wartoci minut
      'w kodzie BCD zamienionych na
      'tekst oraz znaku :
  Wart_bcd = Makebcd(sekundy)                               'zamiana wartoci Sekundy na
      'warto w kodzie BCD
  Lcd Bcd(wart_bcd) ;                                       'wywietlenie wartoci sekund
      'w kodzie BCD zamienionych na
      'tekst
  Reset Nowa_w                                              'zerowanie flagi Nowa_w
 End If
End Sub                                                     'koniec procedury

Odmierz_1s:                                                 'podprogramu obsugi przerwania
      'przepenienia od Timer1
 Counter1 = Counter1 + 34286                                'wpisanie wartoci pocztkowej
      'licznika
 Incr Sekundy                                               'zwikszenie o 1 wartoci
      'Sekundy
 Set Nowa_w                                                 'zezwolenie na wywietlenie
      'czasu
 If Sekundy = 60 Then                                       'jeli Sekundy = 60, to
  Sekundy = 0                                               'wyzerowanie wartoci Sekundy
  Incr Minuty                                               'zwikszenie o 1 wartoci Minuty
  If Minuty = 60 Then                                       'jeli Minuty = 60, to
   Minuty = 0                                               'zerowanie wartoci Minuty
   Incr Godziny                                             'zwikszenie o 1 wartoci
      'Godziny
   If Godziny = 24 Then                                     'jeli Godziny = 24, to
    Godziny = 0                                             'zerowanie wartoci Godziny
   End If                                                   'koniec warunkw
  End If
 End If
Return                                                      'powrt z przerwania
